#!/bin/sh

echo 2 > /proc/sys/vm/overcommit_memory
echo 100 > /proc/sys/vm/overcommit_ratio

echo "Start firmware upgrading"
echo "Start firmware upgrading" > /dev/console
md5_cur=`busybox md5sum ./linux.bin | cut -d' ' -f 1`
md5_img=`cat md5_linux`
if [ "$md5_cur" != "$md5_img" ]; then
    echo "UPGRADE FAIL: Incorrect CRC";
    exit 1;
fi

killall igmpproxy udpxy
chmod 777 /tmp/auto_fw_upgrade/utils/stop_voip
/tmp/auto_fw_upgrade/utils/stop_voip
chmod 777 /tmp/fw/utils/stop_voip
/tmp/fw/utils/stop_voip
chmod 777 /tmp/fw/utils/stop_voip
/tmp/fw_tr069/utils/stop_voip
chmod 777 /tmp/dhcp_fw_upgrade/utils/stop_voip
/tmp/dhcp_fw_upgrade/utils/stop_voip
chmod 777 /tmp/fw/utils/upgrade-bin
chmod 777 /tmp/fw_tr069/utils/upgrade-bin
chmod 777 /tmp/auto_fw_upgrade/utils/upgrade-bin
chmod 777 /tmp/dhcp_fw_upgrade/utils/upgrade-bin

echo "Stopping VoIP service" > /dev/console
kill `ps| grep "/bin/run_daemon.sh voip"|head -n 1|cut -d' ' -f 2`
echo "" > /tmp/restart_voip

sleep 3
sleep 3
killall voip
sleep 3

cur_major=$(cat /version|cut -d'.' -f 1)
cur_minor=$(cat /version|cut -d'.' -f 2)

#Workaround for 1.5.0
if [ $cur_major -eq 1 ]; then
    if [ $cur_minor -eq 5 ]; then
	mv /bin/factory /bin/_factory
    fi
fi

echo "Upgrade firmware started"
echo "Upgrade firmware started" > /dev/console
if [ -f /tmp/fw/utils/upgrade-bin ]; then
    /tmp/fw/utils/upgrade-bin ./linux.bin &> /dev/console
    RETVAL=$?
else
    if [ -f /tmp/auto_fw_upgrade/utils/upgrade-bin ]; then
	/tmp/auto_fw_upgrade/utils/upgrade-bin ./linux.bin &> /dev/console
	RETVAL=$?
    else
	if [ -f /tmp/dhcp_fw_upgrade/utils/upgrade-bin ]; then
	    /tmp/dhcp_fw_upgrade/utils/upgrade-bin ./linux.bin &> /dev/console
	    RETVAL=$?
	else
	    /tmp/fw_tr069/utils/upgrade-bin ./linux.bin &> /dev/console
	    RETVAL=$?
	fi
    fi
fi

if [ "$RETVAL" != "0" ]; then
    if [ "$RETVAL" = "254" ]; then
	echo "UPGRADE FAIL: upgrade process is already in progress" > /dev/console;
	echo "UPGRADE FAIL: upgrade process is already in progress";
	exit 2;
    fi
    echo "UPGRADE FAIL: Error at read/write operation" > /dev/console;
    echo "UPGRADE FAIL: Error at read/write operation";
    exit 1;
fi
if [ $cur_major -eq 1 ]; then
    if [ $cur_minor -eq 5 ]; then
	mv /bin/_factory /bin/factory
    fi
fi

echo "UPGRADE SUCCESSFULL" > /dev/console
echo "UPGRADE SUCCESSFULL"
exit 0;
